org.apache.fop.render.pcl.fonts.truetype

## Class PCLTTFFontReader

- java.lang.Object
- - org.apache.fop.render.pcl.fonts.PCLFontReader
  - - org.apache.fop.render.pcl.fonts.truetype.PCLTTFFontReader

-     public class PCLTTFFontReader
      extends PCLFontReader

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected InputStream` | `fontStream`
    `protected FontFileReader` | `reader`
    `protected TTFFile` | `ttfFont`

    - ### Fields inherited from class org.apache.fop.render.pcl.fonts.PCLFontReader

      `font, typeface`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `PCLTTFFontReader(Typeface font)`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected byte[]` | `createHmtx(Map<Character,Integer> mappedGlyphs)`
    `int` | `getBaselinePosition()`
    `int` | `getCapHeight()`
    `int` | `getCellHeight()`
    `int` | `getCellWidth()`
    `Map<Integer,int[]>` | `getCharacterOffsets()` Character Definitions
    `protected static int` | `getCheckSum(byte[] data, int start, int size)`
    `int` | `getDescriptorSize()` Header Data
    `int` | `getFirstCode()`
    `OpenFont` | `getFontFile()`
    `FontFileReader` | `getFontFileReader()`
    `String` | `getFontName()`
    `int` | `getFontNumber()`
    `int` | `getFontScalingTechnology()`
    `List<PCLFontSegment>` | `getFontSegments(Map<Character,Integer> mappedGlyphs)` Segmented Font Data
    `int` | `getFontType()`
    `int` | `getHeaderFormat()`
    `int` | `getHeight()`
    `int` | `getHeightExtended()`
    `int` | `getLastCode()`
    `int` | `getMasterUnderlinePosition()`
    `int` | `getMasterUnderlineThickness()`
    `int` | `getOrientation()`
    `int` | `getPitch()`
    `int` | `getPitchExtended()`
    `int` | `getPlacement()`
    `int` | `getQuality()`
    `int` | `getScaleFactor()`
    `int` | `getSerifStyle()`
    `int` | `getSpacing()`
    `int` | `getStrokeWeight()`
    `int` | `getStyleLSB()`
    `int` | `getStyleMSB()`
    `int` | `getSymbolSet()`
    `int` | `getTextHeight()`
    `int` | `getTextWidth()`
    `int` | `getTypefaceLSB()`
    `int` | `getTypefaceMSB()`
    `int` | `getUnderlinePosition()`
    `int` | `getUnderlineThickness()`
    `int` | `getVariety()`
    `int` | `getWidthType()`
    `int` | `getXHeight()`
    `protected void` | `loadFont()`
    `protected void` | `readFontTables()`
    `Map<Integer,Integer>` | `scanMtxCharacters()`

    - ### Methods inherited from class org.apache.fop.render.pcl.fonts.PCLFontReader

      `getLSB, getMSB, setFont`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### ttfFont

          protected TTFFile ttfFont

    - #### fontStream

          protected InputStream fontStream

    - #### reader

          protected FontFileReader reader

  - ### Constructor Detail

    - #### PCLTTFFontReader

          public PCLTTFFontReader(Typeface font)
                           throws IOException

      Throws:
        `IOException`

  - ### Method Detail

    - #### loadFont

          protected void loadFont()
                           throws IOException

      Throws:
        `IOException`

    - #### readFontTables

          protected void readFontTables()
                                 throws IOException

      Throws:
        `IOException`

    - #### getDescriptorSize

          public int getDescriptorSize()

      Description copied from class: `PCLFontReader`
      Header Data
      Specified by:
        `getDescriptorSize` in class `PCLFontReader`

    - #### getHeaderFormat

          public int getHeaderFormat()

      Specified by:
        `getHeaderFormat` in class `PCLFontReader`

    - #### getFontType

          public int getFontType()

      Specified by:
        `getFontType` in class `PCLFontReader`

    - #### getStyleMSB

          public int getStyleMSB()

      Specified by:
        `getStyleMSB` in class `PCLFontReader`

    - #### getBaselinePosition

          public int getBaselinePosition()

      Specified by:
        `getBaselinePosition` in class `PCLFontReader`

    - #### getCellWidth

          public int getCellWidth()

      Specified by:
        `getCellWidth` in class `PCLFontReader`

    - #### getCellHeight

          public int getCellHeight()

      Specified by:
        `getCellHeight` in class `PCLFontReader`

    - #### getOrientation

          public int getOrientation()

      Specified by:
        `getOrientation` in class `PCLFontReader`

    - #### getSpacing

          public int getSpacing()

      Specified by:
        `getSpacing` in class `PCLFontReader`

    - #### getSymbolSet

          public int getSymbolSet()

      Specified by:
        `getSymbolSet` in class `PCLFontReader`

    - #### getPitch

          public int getPitch()

      Specified by:
        `getPitch` in class `PCLFontReader`

    - #### getHeight

          public int getHeight()

      Specified by:
        `getHeight` in class `PCLFontReader`

    - #### getXHeight

          public int getXHeight()

      Specified by:
        `getXHeight` in class `PCLFontReader`

    - #### getWidthType

          public int getWidthType()

      Specified by:
        `getWidthType` in class `PCLFontReader`

    - #### getStyleLSB

          public int getStyleLSB()

      Specified by:
        `getStyleLSB` in class `PCLFontReader`

    - #### getStrokeWeight

          public int getStrokeWeight()

      Specified by:
        `getStrokeWeight` in class `PCLFontReader`

    - #### getTypefaceLSB

          public int getTypefaceLSB()

      Specified by:
        `getTypefaceLSB` in class `PCLFontReader`

    - #### getTypefaceMSB

          public int getTypefaceMSB()

      Specified by:
        `getTypefaceMSB` in class `PCLFontReader`

    - #### getSerifStyle

          public int getSerifStyle()

      Specified by:
        `getSerifStyle` in class `PCLFontReader`

    - #### getQuality

          public int getQuality()

      Specified by:
        `getQuality` in class `PCLFontReader`

    - #### getPlacement

          public int getPlacement()

      Specified by:
        `getPlacement` in class `PCLFontReader`

    - #### getUnderlinePosition

          public int getUnderlinePosition()

      Specified by:
        `getUnderlinePosition` in class `PCLFontReader`

    - #### getUnderlineThickness

          public int getUnderlineThickness()

      Specified by:
        `getUnderlineThickness` in class `PCLFontReader`

    - #### getTextHeight

          public int getTextHeight()

      Specified by:
        `getTextHeight` in class `PCLFontReader`

    - #### getTextWidth

          public int getTextWidth()

      Specified by:
        `getTextWidth` in class `PCLFontReader`

    - #### getFirstCode

          public int getFirstCode()

      Specified by:
        `getFirstCode` in class `PCLFontReader`

    - #### getLastCode

          public int getLastCode()

      Specified by:
        `getLastCode` in class `PCLFontReader`

    - #### getPitchExtended

          public int getPitchExtended()

      Specified by:
        `getPitchExtended` in class `PCLFontReader`

    - #### getHeightExtended

          public int getHeightExtended()

      Specified by:
        `getHeightExtended` in class `PCLFontReader`

    - #### getCapHeight

          public int getCapHeight()

      Specified by:
        `getCapHeight` in class `PCLFontReader`

    - #### getFontNumber

          public int getFontNumber()

      Specified by:
        `getFontNumber` in class `PCLFontReader`

    - #### getFontName

          public String getFontName()

      Specified by:
        `getFontName` in class `PCLFontReader`

    - #### getScaleFactor

          public int getScaleFactor()
                             throws IOException

      Specified by:
        `getScaleFactor` in class `PCLFontReader`
      Throws:
        `IOException`

    - #### getMasterUnderlinePosition

          public int getMasterUnderlinePosition()
                                         throws IOException

      Specified by:
        `getMasterUnderlinePosition` in class `PCLFontReader`
      Throws:
        `IOException`

    - #### getMasterUnderlineThickness

          public int getMasterUnderlineThickness()
                                          throws IOException

      Specified by:
        `getMasterUnderlineThickness` in class `PCLFontReader`
      Throws:
        `IOException`

    - #### getFontScalingTechnology

          public int getFontScalingTechnology()

      Specified by:
        `getFontScalingTechnology` in class `PCLFontReader`

    - #### getVariety

          public int getVariety()

      Specified by:
        `getVariety` in class `PCLFontReader`

    - #### getFontSegments

          public List<PCLFontSegment> getFontSegments(Map<Character,Integer> mappedGlyphs)
                                               throws IOException

      Description copied from class: `PCLFontReader`
      Segmented Font Data
      Specified by:
        `getFontSegments` in class `PCLFontReader`
      Throws:
        `IOException`

    - #### getCharacterOffsets

          public Map<Integer,int[]> getCharacterOffsets()
                                                 throws IOException

      Description copied from class: `PCLFontReader`
      Character Definitions
      Specified by:
        `getCharacterOffsets` in class `PCLFontReader`
      Throws:
        `IOException`

    - #### getFontFile

          public OpenFont getFontFile()

      Specified by:
        `getFontFile` in class `PCLFontReader`

    - #### getFontFileReader

          public FontFileReader getFontFileReader()

      Specified by:
        `getFontFileReader` in class `PCLFontReader`

    - #### getCheckSum

          protected static int getCheckSum(byte[] data,
                                           int start,
                                           int size)

    - #### createHmtx

          protected byte[] createHmtx(Map<Character,Integer> mappedGlyphs)

    - #### scanMtxCharacters

          public Map<Integer,Integer> scanMtxCharacters()
                                                 throws IOException

      Specified by:
        `scanMtxCharacters` in class `PCLFontReader`
      Throws:
        `IOException`

Copyright © 2023 Apache Software Foundation. All rights reserved.